diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 4416e744b..bda14c8c8 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -5,6 +5,7 @@ import static org.lwjgl.opengl.GL11.*;
 import java.util.List;
 import java.util.Random;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.phys.Vec3;
@@ -16,12 +17,11 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.particle.WaterDropParticle;
 import net.minecraft.client.entity.particle.SmokeParticle;
 import net.minecraft.client.entity.player.LocalPlayer;
-import net.minecraft.client.gui.GuiPhotoMode;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
+import net.minecraft.client.gui.PhotoModeScreen;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.MouseFilter;
 import net.minecraft.client.input.PlayerInput;
-import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.CameraUtil;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.camera.EntityCameraFirstPerson;
@@ -47,9 +47,11 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.weather.Weather;
+import org.slf4j.Logger;
 
 public class WorldRenderer
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static final long nsPerSecond = 1_000_000_000L;
     public final LightmapHelper lightmapHelper;
     public Minecraft mc;
@@ -58,12 +60,12 @@ public class WorldRenderer
     public FogManager fogManager;
     private int rendererUpdateCount;
     private Entity pointedEntity;
-    private MouseFilter mouseFilterXAxis;
-    private MouseFilter mouseFilterYAxis;
+    private final MouseFilter mouseFilterXAxis;
+    private final MouseFilter mouseFilterYAxis;
     private float fovModifier;
     private float fovModifierLast;
     private long systemTime;
-    private Random random;
+    private final Random random;
     private int rainSoundCounter;
     public boolean zooming = false;
     private float zoomProgress;
@@ -263,7 +265,7 @@ public class WorldRenderer
         if (mc.activeCamera instanceof EntityCamera)
         {
             Mob entityliving = ((EntityCamera) mc.activeCamera).mob;
-            if (mc.currentScreen instanceof GuiPhotoMode)
+            if (mc.currentScreen instanceof PhotoModeScreen)
             {
                 mc.activeCamera = new EntityCameraIsometric(mc, entityliving);
             }
@@ -298,16 +300,16 @@ public class WorldRenderer
         setupCamera(partialTick);
         mc.activeCamera.applyGlTransformations();
 
-        if(!(mc.currentScreen instanceof GuiPhotoMode) && !mc.gameSettings.lockCamera.value)
+        if(!(mc.currentScreen instanceof PhotoModeScreen) && !mc.gameSettings.lockCamera.value)
         {
             glRotatef((float) mc.activeCamera.getXRot(partialTick), 1.0F, 0.0F, 0.0F);
             glRotatef((float) (mc.activeCamera.getYRot(partialTick) + 180F), 0.0F, 1.0F, 0.0F);
         }
 
-        if (mc.currentScreen instanceof GuiPhotoMode)
+        if (mc.currentScreen instanceof PhotoModeScreen)
         {
-            glRotatef(((GuiPhotoMode)mc.currentScreen).getTilt(partialTick), 1.0F, 0.0F, 0.0F);
-            glRotatef(45f + 45F * ((GuiPhotoMode)mc.currentScreen).getRotation(partialTick), 0.0F, 1.0F, 0.0F);
+            glRotatef(((PhotoModeScreen)mc.currentScreen).getTilt(partialTick), 1.0F, 0.0F, 0.0F);
+            glRotatef(45f + 45F * ((PhotoModeScreen)mc.currentScreen).getRotation(partialTick), 0.0F, 1.0F, 0.0F);
         }
     }
 
@@ -322,12 +324,12 @@ public class WorldRenderer
         } else {
             zoomProgress = 0;
         }
-        if (mc.currentScreen instanceof GuiPhotoMode)
+        if (mc.currentScreen instanceof PhotoModeScreen)
         {
-            double div = java.lang.Math.pow(2, ((GuiPhotoMode)mc.currentScreen).getZoom(partialTick));
+            double div = java.lang.Math.pow(2, ((PhotoModeScreen)mc.currentScreen).getZoom(partialTick));
             glTranslatef(1, 1, 0);
             glOrtho(0, mc.resolution.width / div, 0, mc.resolution.height / div, farPlaneDistance * -2.0f, farPlaneDistance * 2.0f);
-            glTranslatef(((GuiPhotoMode)mc.currentScreen).getPanX(partialTick), -((GuiPhotoMode)mc.currentScreen).getPanY(partialTick), 0);
+            glTranslatef(((PhotoModeScreen)mc.currentScreen).getPanX(partialTick), -((PhotoModeScreen)mc.currentScreen).getPanY(partialTick), 0);
         } else
         {
             GLU.gluPerspective(fov, (float)mc.resolution.width / (float)mc.resolution.height, 0.05F, farPlaneDistance * 2.0F);
@@ -335,7 +337,7 @@ public class WorldRenderer
         glMatrixMode(GL_MODELVIEW);
         glLoadIdentity();
         hurtCameraEffect(partialTick);
-        if(mc.gameSettings.viewBobbing.value && !(mc.currentScreen instanceof GuiPhotoMode))
+        if(mc.gameSettings.viewBobbing.value && !(mc.currentScreen instanceof PhotoModeScreen))
         {
             setupViewBobbing(partialTick);
         }
@@ -375,7 +377,7 @@ public class WorldRenderer
         {
             setupViewBobbing(partialTick);
         }
-        if(mc.gameSettings.thirdPersonView.value == 0 && !(mc.currentScreen instanceof GuiPhotoMode) && !(!(mc.activeCamera instanceof EntityCamera) || ((EntityCamera) mc.activeCamera).mob.isPlayerSleeping()) && mc.gameSettings.immersiveMode.drawHand())
+        if(mc.gameSettings.thirdPersonView.value == 0 && !(mc.currentScreen instanceof PhotoModeScreen) && !(!(mc.activeCamera instanceof EntityCamera) || ((EntityCamera) mc.activeCamera).mob.isPlayerSleeping()) && mc.gameSettings.immersiveMode.drawHand())
         {
             lightmapHelper.enableLightmapRendering();
             if(!zooming) itemRenderer.renderItemInFirstPerson(partialTick);
@@ -524,9 +526,9 @@ public class WorldRenderer
                     {
                         Thread.sleep(l1);
                     }
-                    catch(InterruptedException interruptedexception)
+                    catch(InterruptedException e)
                     {
-                        interruptedexception.printStackTrace();
+                        LOGGER.error("", e);
                     }
                 }
                 Debug.change("misc");
@@ -534,7 +536,7 @@ public class WorldRenderer
             systemTime = System.nanoTime();
             
             Debug.change("hud");
-            mc.ingameGUI.renderGameOverlay(partialTick, mc.currentScreen != null, mouseX, mouseY);
+            mc.ingameHud.renderGameOverlay(partialTick, mc.currentScreen != null, mouseX, mouseY);
             Debug.change("misc");
         } else
         {
@@ -557,9 +559,9 @@ public class WorldRenderer
                     {
                         Thread.sleep(l2);
                     }
-                    catch(InterruptedException interruptedexception1)
+                    catch(InterruptedException e)
                     {
-                        interruptedexception1.printStackTrace();
+                        LOGGER.error("", e);
                     }
                 }
                 Debug.change("misc");
@@ -574,7 +576,7 @@ public class WorldRenderer
                 mouseX = (int) mc.controllerInput.cursorX;
                 mouseY = (int) mc.controllerInput.cursorY;
             }
-            mc.currentScreen.drawScreen(mouseX, mouseY, partialTick);
+            mc.currentScreen.render(mouseX, mouseY, partialTick);
             if(mc.inputType == InputType.CONTROLLER && mc.currentScreen != null) {
                 mc.currentScreen.drawControllerCursor();
             }
@@ -588,7 +590,7 @@ public class WorldRenderer
         Colorizers.update(false);
         
         RenderGlobal renderGlobal = mc.renderGlobal;
-        EffectRenderer effectRenderer = mc.effectRenderer;
+        ParticleEngine particleEngine = mc.particleEngine;
         
         glEnable(GL_CULL_FACE);
         glEnable(GL_DEPTH_TEST);
@@ -626,7 +628,7 @@ public class WorldRenderer
         setupCameraTransform(partialTicks);
         Frustum.getFrustum();
         Debug.change("sky");
-        if((mc.gameSettings.renderDistance.value > 4) /* Used to use Renderdistance rendersky! */ && !(mc.currentScreen instanceof GuiModelViewer))
+        if((mc.gameSettings.renderDistance.value > 4) /* Used to use Renderdistance rendersky! */ && !(mc.currentScreen instanceof ModelViewerScreen))
         {
             fogManager.setupFog(FogManager.FOG_MODE_SKY, farPlaneDistance, partialTicks);
             glDisable(GL_FOG);
@@ -691,10 +693,10 @@ public class WorldRenderer
         }
         
         Debug.change("particles");
-        effectRenderer.renderParticlesAtOrigin(partialTicks);
+        particleEngine.renderLitParticles(mc.activeCamera, partialTicks);
         Lighting.disable();
         fogManager.setupFog(FogManager.FOG_MODE_NORMAL, farPlaneDistance, partialTicks);
-        effectRenderer.renderParticles(mc.activeCamera, partialTicks);
+        particleEngine.renderParticles(mc.activeCamera, partialTicks);
 
         lightmapHelper.disableLightmapRendering();
         
@@ -810,7 +812,7 @@ public class WorldRenderer
             }
             if(Block.blocksList[i2].blockMaterial == Material.lava)
             {
-                mc.effectRenderer.addEffect(new SmokeParticle(world, (float)randX + f1, (double)((float)y + 0.1F) - Block.blocksList[i2].minY, (float)randZ + f2, 0.0D, 0.0D, 0.0D));
+                mc.particleEngine.add(new SmokeParticle(world, (float)randX + f1, (double)((float)y + 0.1F) - Block.blocksList[i2].minY, (float)randZ + f2, 0.0D, 0.0D, 0.0D));
                 continue;
             }
             if(random.nextInt(++l) == 0)
@@ -819,7 +821,7 @@ public class WorldRenderer
                 d1 = (double)((float)y + 0.1F) - Block.blocksList[i2].minY;
                 d2 = (float)randZ + f2;
             }
-            mc.effectRenderer.addEffect(new WaterDropParticle(world, (float)randX + f1, (double)((float)y + 0.1F) - Block.blocksList[i2].minY, (float)randZ + f2));
+            mc.particleEngine.add(new WaterDropParticle(world, (float)randX + f1, (double)((float)y + 0.1F) - Block.blocksList[i2].minY, (float)randZ + f2));
         }
 
         if(l > 0 && random.nextInt(3) < rainSoundCounter++)
@@ -851,7 +853,7 @@ public class WorldRenderer
         glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
         glAlphaFunc(516, 0.01F);
 
-        mc.renderEngine.loadTexture(weather.getPrecipitationTexture(world)).bind();
+        mc.textureManager.loadTexture(weather.getPrecipitationTexture(world)).bind();
         
         double nextPosX = mc.activeCamera.getX(partialTick);
         double nextPosY = mc.activeCamera.getY(partialTick);
@@ -922,9 +924,9 @@ public class WorldRenderer
                 blockedWeather:
                 for(int z = posZ - radiusEffect; z <= posZ + radiusEffect; z++) {
                     int y = world.findTopSolidBlock(x, z);
-                    Biome biomegenbase1 = world.getBlockBiome(x, y, z);
-                    for (int q = 0; q < biomegenbase1.blockedWeathers.length; q++) {
-                        if (biomegenbase1.blockedWeathers[q] == weather) {
+                    Biome biome = world.getBlockBiome(x, y, z);
+                    for (int q = 0; q < biome.blockedWeathers.length; q++) {
+                        if (biome.blockedWeathers[q] == weather) {
                             continue blockedWeather;
                         }
                     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index d74eae690..02887fe03 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -56,7 +56,7 @@ public abstract class BlockModel<T extends Block>
     public void resetRenderBlocks(){
         renderBlocks.renderAllFaces = false;
         renderBlocks.enableAO = false;
-        renderBlocks.overbright = false;
+//        renderBlocks.overbright = false;
         renderBlocks.useInventoryTint = true;
         renderBlocks.flipTexture = false;
         renderBlocks.overrideBlockTexture = null;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index cadad76b5..4cc8d5591 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -19,12 +19,12 @@ public class BlockModelDispatcher
         addDispatch(dispatchable.block, dispatchable);
     }
     @Override
-    public void addDispatch(Block item, BlockModel dispatchable)
+    public void addDispatch(Block key, BlockModel value)
     {
-        if (dispatches.containsValue(item)){
-            throw new IllegalArgumentException("Block '" + item.toString() + "' already assigned a model!");
+        if (dispatches.containsValue(key)){
+            throw new IllegalArgumentException("Block '" + key.toString() + "' already assigned a model!");
         }
-        dispatches.put(item, dispatchable);
+        dispatches.put(key, value);
     }
     @Override
     protected BlockModel getDefault()
diff --git a/src/main/java/net/minecraft/client/render/block/model/RepeaterBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/RepeaterBlockModel.java
index 827541ee0..4defe0983 100644
--- a/src/main/java/net/minecraft/client/render/block/model/RepeaterBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/RepeaterBlockModel.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.RepeaterBlock;
@@ -52,9 +53,9 @@ public class RepeaterBlockModel extends StandardBlockModel<RepeaterBlock> {
         	tessellator.setLightmapCoord(lmc);
         }else {
     		brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-    		if(Block.lightEmission[block.id] > 0) {
+    		if(Block.lightEmission[block.id] > 0 || Global.accessor.isFullbrightEnabled()) {
     			brightness = 1.0f;
-    		}	
+    		}
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
         double d = -0.1875D;
@@ -85,8 +86,13 @@ public class RepeaterBlockModel extends StandardBlockModel<RepeaterBlock> {
                 break;
         }
         TorchBlockModel<Block> modelTorch = block.isRepeaterPowered ? modelTorchActive : modelTorchIdle;
-        modelTorch.renderTorchAtAngle(tessellator, (double)x + d1, (double)y + d, (double)z + d2, 0.0D, 0.0D);
-        modelTorch.renderTorchAtAngle(tessellator, (double)x + d3, (double)y + d, (double)z + d4, 0.0D, 0.0D);
+        if (renderBlocks.overbright && block.isRepeaterPowered) {
+            modelTorch.renderTorchAtAngle(tessellator, (double)x + d1, (double)y + d, (double)z + d2, 0.0D, 0.0D);
+            modelTorch.renderTorchAtAngle(tessellator, (double)x + d3, (double)y + d, (double)z + d4, 0.0D, 0.0D);
+        } else if (!renderBlocks.overbright) {
+            modelTorch.renderTorchAtAngle(tessellator, (double)x + d1, (double)y + d, (double)z + d2, 0.0D, 0.0D);
+            modelTorch.renderTorchAtAngle(tessellator, (double)x + d3, (double)y + d, (double)z + d4, 0.0D, 0.0D);
+        }
         return true;
     }
     @Override
diff --git a/src/main/java/net/minecraft/client/render/blockentity/BlockEntityRenderer.java b/src/main/java/net/minecraft/client/render/blockentity/BlockEntityRenderer.java
index bd9dd308a..887f15cf6 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/BlockEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/BlockEntityRenderer.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.blockentity;
 
-import net.minecraft.client.render.FontRenderer;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.Font;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.entity.BlockEntity;
@@ -19,8 +19,8 @@ public abstract class BlockEntityRenderer<T extends BlockEntity>
 
     protected void loadTexture(String texturePath)
     {
-        RenderEngine renderengine = renderDispatcher.renderEngine;
-        renderengine.bindTexture(renderengine.loadTexture(texturePath));
+        TextureManager textureManager = renderDispatcher.textureManager;
+        textureManager.bindTexture(textureManager.loadTexture(texturePath));
     }
 
     public void setRenderDispatcher(BlockEntityRenderDispatcher renderDispatcher)
@@ -32,9 +32,9 @@ public abstract class BlockEntityRenderer<T extends BlockEntity>
     {
     }
 
-    public FontRenderer getFontRenderer()
+    public Font getFont()
     {
-        return renderDispatcher.getFontRenderer();
+        return renderDispatcher.getFont();
     }
 
     protected BlockEntityRenderDispatcher renderDispatcher;
diff --git a/src/main/java/net/minecraft/client/render/blockentity/FlagBlockEntityRenderer.java b/src/main/java/net/minecraft/client/render/blockentity/FlagBlockEntityRenderer.java
index 824274de5..1183fc4b0 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/FlagBlockEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/FlagBlockEntityRenderer.java
@@ -41,7 +41,7 @@ public class FlagBlockEntityRenderer extends BlockEntityRenderer<FlagBlockEntity
     {
         if (flagRenderer == null)
         {
-            flagRenderer = new FlagRenderer(renderDispatcher.renderEngine);
+            flagRenderer = new FlagRenderer(renderDispatcher.textureManager);
         }
         flagRenderer.updateTexture(tileEntity);
         
@@ -68,7 +68,7 @@ public class FlagBlockEntityRenderer extends BlockEntityRenderer<FlagBlockEntity
         GL11.glPushMatrix();
         GL11.glRotatef(windDirection + sway, 0.0f, 1.0f, 0.0f);
         flagModel.renderFlag();
-        renderDispatcher.renderEngine.bindTexture(flagRenderer.getTexture());
+        renderDispatcher.textureManager.bindTexture(flagRenderer.getTexture());
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_ONE_MINUS_SRC_COLOR, GL11.GL_SRC_COLOR);
         flagModel.renderFlagOverlay();
diff --git a/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java b/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
index 417b93bf0..01785c6bc 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/SignBlockEntityRenderer.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.blockentity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.model.SignModel;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -71,7 +71,7 @@ public class SignBlockEntityRenderer extends BlockEntityRenderer<SignBlockEntity
         GL11.glScalef(scale, -scale, -scale);
         signModel.func_887_a();
         GL11.glPopMatrix();
-        FontRenderer fontrenderer = getFontRenderer();
+        Font font = getFont();
 
         // Render overlay
         GL11.glPushMatrix();
@@ -114,7 +114,7 @@ public class SignBlockEntityRenderer extends BlockEntityRenderer<SignBlockEntity
             {
                 text = "> " + text + " <";
             }
-            fontrenderer.drawString(text, -fontrenderer.getStringWidth(text) / 2, line * 10 - tileEntity.signText.length * 5, color);
+            font.drawString(text, -font.getStringWidth(text) / 2, line * 10 - tileEntity.signText.length * 5, color);
         }
         GL11.glPopMatrix();
 
diff --git a/src/main/java/net/minecraft/client/render/camera/EntityCameraIsometric.java b/src/main/java/net/minecraft/client/render/camera/EntityCameraIsometric.java
index 59fb70b86..6eba0fcae 100644
--- a/src/main/java/net/minecraft/client/render/camera/EntityCameraIsometric.java
+++ b/src/main/java/net/minecraft/client/render/camera/EntityCameraIsometric.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.render.camera;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiPhotoMode;
+import net.minecraft.client.gui.PhotoModeScreen;
 import net.minecraft.core.entity.Mob;
 
 public class EntityCameraIsometric
@@ -13,9 +13,9 @@ public class EntityCameraIsometric
 
     @Override
     public boolean showPlayer() {
-        if (mc.currentScreen instanceof GuiPhotoMode)
+        if (mc.currentScreen instanceof PhotoModeScreen)
         {
-            return ((GuiPhotoMode)mc.currentScreen).showPlayer;
+            return ((PhotoModeScreen)mc.currentScreen).showPlayer;
         }
 
         return true;
diff --git a/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java b/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
index c5228dce4..b33ce4ee2 100644
--- a/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
+++ b/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
@@ -8,6 +8,7 @@ import java.util.List;
 
 import javax.imageio.ImageIO;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.core.Global;
@@ -17,9 +18,10 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.SeasonManagerCycle;
 import net.minecraft.core.world.season.Seasons;
+import org.slf4j.Logger;
 
 public class Colorizers {
-	
+	private static final Logger LOGGER = LogUtils.getLogger();
 	public static Minecraft mc;
 	
 	private static List<Colorizer> allColorizers = null;
@@ -58,7 +60,7 @@ public class Colorizers {
 			colorizer.setup(mc, seasons);
 			TexturePack texturePack = colorizer.getTexturePack();
 			if(texturePack != null) {
-				System.out.println("Using " + colorizer.name + " color from texture pack " + texturePack.fileName);	
+                LOGGER.info("Using {} color from texture pack {}", colorizer.name, texturePack.fileName);
 			}
 		}
 	}
@@ -117,7 +119,7 @@ public class Colorizers {
 		lastSeason = currentSeason;
 		lastSeasonProgress = seasonProgress;
 		
-		System.out.println("Updating Colorizers");
+		LOGGER.info("Updating Colorizers");
 		
 		Season season1, season2;
 		float blendFactor;
@@ -200,7 +202,9 @@ public class Colorizers {
 			throw new RuntimeException("Loading colormap: '" + path + "'", e);
 		}finally {
 			try {
-				in.close();
+				if (in != null) {
+					in.close();
+				}
 			}catch (Exception e) {}
 		}
 
diff --git a/src/main/java/net/minecraft/client/render/customatlas/CustomAtlasHandler.java b/src/main/java/net/minecraft/client/render/customatlas/CustomAtlasHandler.java
index b1f3c7740..8ba478553 100644
--- a/src/main/java/net/minecraft/client/render/customatlas/CustomAtlasHandler.java
+++ b/src/main/java/net/minecraft/client/render/customatlas/CustomAtlasHandler.java
@@ -10,14 +10,17 @@ import java.util.Map;
 import java.util.zip.ZipEntry;
 import java.util.zip.ZipFile;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.client.render.texturepack.TexturePackCustom;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.client.util.helper.Textures;
+import net.minecraft.core.Global;
+import org.slf4j.Logger;
 
 public class CustomAtlasHandler {
-
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private static Atlas legacyTerrainAtlas = null;
 	private static Atlas legacyItemsAtlas = null;
 	
@@ -204,7 +207,7 @@ public class CustomAtlasHandler {
 	}
 	
 	public static void log(String str) {
-		System.out.println(str);
+		LOGGER.info(str);
 	}
 	
 	static interface Filter {
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
index f473eab84..f16e4bb50 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
@@ -3,12 +3,14 @@ package net.minecraft.client.render.dynamictexture;
 import java.awt.image.BufferedImage;
 import java.util.Random;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.render.texture.meta.AnimationProperties;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texturepack.TexturePackException;
+import org.slf4j.Logger;
 
 public class DynamicTextureCustom extends DynamicTexture {
-	
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private static final Random rand = new Random();
 	
 	private final int frameCount;
@@ -153,7 +155,7 @@ public class DynamicTextureCustom extends DynamicTexture {
 				}
 			}
 		} catch (Exception e) {
-			e.printStackTrace();
+            LOGGER.error("Exception while transferring frame '{}'!", frame, e);
 		}
 	}
 	
diff --git a/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index 01ee41827..b70f3f9a1 100644
--- a/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -3,10 +3,10 @@ package net.minecraft.client.render.entity;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.render.EntityRenderDispatcher;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.ImageParser;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -38,11 +38,11 @@ public abstract class EntityRenderer<T extends Entity>
 
     protected void bindTexture(String texturePath)
     {
-        RenderEngine renderEngine = renderDispatcher.renderEngine;
-        renderEngine.bindTexture(renderEngine.loadTexture(texturePath));
+        TextureManager textureManager = renderDispatcher.textureManager;
+        textureManager.bindTexture(textureManager.loadTexture(texturePath));
     }
     public boolean bindDownloadableTexture(String urlTexture, String backupTexture, ImageParser imageParser) {
-        return renderDispatcher.renderEngine.bindDownloadableTexture(urlTexture, backupTexture, imageParser);
+        return renderDispatcher.textureManager.bindDownloadableTexture(urlTexture, backupTexture, imageParser);
     }
     
     private void renderFire(Tessellator tessellator, T entity, double x, double y, double z, float partialTick)
@@ -101,8 +101,8 @@ public abstract class EntityRenderer<T extends Entity>
     {
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        RenderEngine renderengine = renderDispatcher.renderEngine;
-        renderengine.bindTexture(renderengine.loadTexture("/assets/minecraft/textures/misc/shadow.png"));
+        TextureManager textureManager = renderDispatcher.textureManager;
+        textureManager.bindTexture(textureManager.loadTexture("/assets/minecraft/textures/misc/shadow.png"));
         World world = getWorld();
         GL11.glDepthMask(false);
         double lerpX = entity.xo + (entity.x - entity.xo) * (double)partialTick;
@@ -281,8 +281,8 @@ public abstract class EntityRenderer<T extends Entity>
         }
     }
 
-    public FontRenderer getFontRenderer()
+    public Font getFont()
     {
-        return renderDispatcher.getFontRenderer();
+        return renderDispatcher.getFont();
     }
 }
